import 'dart:async';
import 'package:flutter/services.dart';
import 'dart:io';

class Mzanalytics_android {
  static const MethodChannel _channel =
      const MethodChannel('mzanalytics_mybmw');

  static Future<void> initEvent() async {
    try {
      _channel.invokeMethod('android_initEvent');
    } on PlatformException catch (e) {}
  }

  static Future<void> android_sendBaseEvent(var parameter) async {
    try {
      _channel.invokeMethod('android_sendBaseEvent', parameter);
    } on PlatformException catch (e) {}
  }

  static Future<void> android_pageEvent(var parameter) async {
    try {
      _channel.invokeMethod('android_pageEvent', parameter);
    } on PlatformException catch (e) {}
  }

  static Future<void> android_seniorEvent(var parameter) async {
    try {
      _channel.invokeMethod('android_seniorEvent', parameter);
    } on PlatformException catch (e) {}
  }

  static Future<void> android_heartEvent() async {
    try {
      _channel.invokeMethod('android_heartEvent');
    } on PlatformException catch (e) {}
  }

  static Future<String> android_getOaid() async {
    try {
      return _channel.invokeMethod('android_getOaid');
    } on PlatformException catch (e) {}
  }

  static Future<String> android_getCid() async {
    try {
      return _channel.invokeMethod('android_getCid');
    } on PlatformException catch (e) {}
  }

  static Future<String> android_setCd(var key, var value) async {
    try {
      return _channel.invokeMethod(
          'setCd', <String, dynamic>{'cd_key': key, "cd_value": value});
    } on PlatformException catch (e) {}
  }

  static Future<String> android_setCm(var key, var value) async {
    try {
      return _channel.invokeMethod(
          'setCm', <String, dynamic>{'cm_key': key, "cm_value": value});
    } on PlatformException catch (e) {}
  }

  static Future<String> android_deleteCd(var key) async {
    try {
      return _channel
          .invokeMethod('deleteCd', <String, dynamic>{'cd_key': key});
    } on PlatformException catch (e) {}
  }

  static Future<String> android_deleteCm(var key) async {
    try {
      return _channel
          .invokeMethod('deleteCm', <String, dynamic>{'cm_key': key});
    } on PlatformException catch (e) {}
  }

  static Future<Map> android_getCdAndCm() async {
    try {
      return _channel.invokeMethod('getCdAndCm');
    } on PlatformException catch (e) {}
  }

  static Future<bool> android_isAutoTrackpage() async {
    try {
      return _channel.invokeMethod('isAutoTrackpage');
    } on PlatformException catch (e) {}
  }

  static Future<List> android_getBlackList() async {
    try {
      return _channel.invokeMethod('getBlackList');
    } on PlatformException catch (e) {}
  }

  /** 自定义cd和cm统一对外方法 */
  static Future<Map> getCdAndCm() async {
    try {
      return _channel.invokeMethod('getCdAndCm');
    } on FileSystemException {
      return null;
    }
  }

  static Future<void> setCd(String cd_key, String cd_value) async {
    try {
      android_setCd(cd_key, cd_value);
    } on FileSystemException {}
  }

  static Future<void> setCm(var cm_key, var cm_value) async {
    try {
      android_setCm(cm_key, cm_value);
    } on FileSystemException {}
  }

  static Future<void> deleteCd(var cd_key) async {
    try {
      android_deleteCd(cd_key);
    } on FileSystemException {}
  }

  static Future<void> deleteCm(var cm_key) async {
    try {
      android_deleteCm(cm_key);
    } on FileSystemException {}
  }

  static Future<bool> isAutoTrackpage() async {
    try {
      return android_isAutoTrackpage();
    } on FileSystemException {}
  }

  static Future<List> getBlackList() async {
    try {
      return android_getBlackList();
    } on FileSystemException {}
  }
}
